#define LOCATOR
#include "sun.h"

/* Wandelt Lnge/Breite in QTH-Loc um */
void locator(Loc l,char *locator)
{
   float lat,lon;
   
   lat = l.lat;
   lon = l.lon;

   strcpy(locator,"xxxxxx");
   /* printf("lon0 = %6.2f\n",lon); */
   locator[0] = (int) ((lon + 180)/20.0) + 'A';
          lon = lon + 180 - (int) ((lon + 180)/20.0) * 20;
   /* printf("lon1 = %6.2f\n",lon);  */
   locator[2] = (int) (lon/2.0) + '0';
          lon = lon - (int) (lon/2.0) * 2;
   /* printf("lon2 = %6.2f\n",lon);  */
   /* *** ORIGINAL falsch locator[4] = (int) (12.0*(lon + 2.5/60.0)) + 'a'; */
   /* meiner Meinung nach korrekt 
        locator[4] = (int) (12.0*(lon - 2.5/60.0)) + 'a';
   */
   locator[4] = (int) (12.0*(lon)) + 'a';  /* empirisch ermittelt */

   /* printf("lat0 = %6.2f\n",lat);  */
   locator[1] = (int) ((lat + 90.0)/10.0) + 'A';
          lat = lat + 90 - (int) ((lat + 90.0)/10.0) * 10;
   /* printf("lat1 = %6.2f\n",lat);  */
   locator[3] = (int) (lat) + '0';
          lat = lat - (int) (lat);
   /* printf("lat2 = %6.2f\n",lat);  */
   /* *** ORIGINAL falsch locator[5] = (int) (24.0*(lat + 1.25/60.0)) + 'a'; */
   /* meiner Meinung nach korrekt 
       locator[5] = (int) (24.0*(lat - 1.25/60.0)) + 'a';
   */
   locator[5] = (int) (24.0*(lat)) + 'a'; /* empirisch ermittelt */

   /* Und wie rechnet man den jetzt um ??? */
}

/* Wandelt QTH-Loc in Lnge/Breite um und fllt */
/* Location-Struktur aus. QTH-Loc wurde vorher  */
/* schon auf Gltigkeit berprft.              */
Location r_locator(char *loc)
{
   Location location;

   strupr(loc);
   location.loc.lat=(*(loc+1)-65.0)*10.0-90.0+(*(loc+3)-48.0);
   location.loc.lat+=(double)(*(loc+5)-65.0)*2.5/60.0+1.25/60.0;
   
   location.loc.lon=(*loc-74)*20.0+(*(loc+2)-48)*2.0;
   location.loc.lon+=(double)(*(loc+4)-65.0)/12.0+2.5/60.0;
#ifdef  DEBUG
   printf("LAT: %.4f deg , LON: %.4f deg\n",location.loc.lat,location.loc.lon);
#endif
   strcpy(location.pref,"qth");
   strcpy(location.name,loc);
   location.timezone=0.0;
   location.qtf=0;
   location.qrb=0;
   location.suntimes.rise=0;
   location.suntimes.set=0;
   
   return(location);
}

int isnum(char *s)
{
        int i,result;
        result = 1;

        for (i=0;i<=strlen(s);i++) {
		if (*s>'9' || *s<'0') {
			result = 0;
                }
                s++;
        }
        return result;
}

/* Test if *s is a valid WW locator string */
int isloc(char *s)
{
	int result;
   
   strupr(s);
	result= (*(s)>='A' && *(s)<='T') &&
		(*(s+1)>='A' && *(s+1)<='T') &&
		isdigit(*(s+2)) &&
      isdigit(*(s+3)) &&
		(*(s+4)>='A' && *(s+4)<='X') &&
		(*(s+5)>='A' && *(s+5)<='X');

	return(result);
}
/* =========================================================== */
double safe_acos(double arg)
{
	if (arg>=  1.0) return 0;
	if (arg<= -1.0) return M_PI;
	return(acos(arg));
}
/* =========================================================== */
void dx(double l1, double b1, double lf, double bf)
{
	double entf,dl;
   int ri;
   
   /* l1: eigener Laengengrad, b1: eigener Breitengrad */
   /* lf: fremder Laengengrad, bf: fremder Breitengrad */
   
   /* Grad in Bogenmass umrechnen */
	l1=l1/180.0*M_PI;
	b1=b1/180.0*M_PI;
	lf=lf/180.0*M_PI;
	bf=bf/180.0*M_PI;	

   dl=l1-lf;
   if (fabs(dl)>=M_PI)
   {
      if (dl<0)
         dl=dl+2*M_PI;
      else
         dl=dl-2*M_PI;
   }
	if (lf!=l1 || bf!=b1)
	{
		entf=safe_acos(cos(l1-lf)*cos(b1)*cos(bf)+sin(b1)*sin(bf));
		ri=safe_acos((sin(bf)-sin(b1)*cos(entf))/sin(entf)/cos(b1))/M_PI*180;

/*		if (l1>lf && l1>=0)
			ri=360-ri;
		if (l1>lf && l1<0 && lf>0)
			ri=360-ri; 
		if (ri>360)
			ri-=360;
		if (ri<0)
			ri+=360;
*/
   	if (dl>0)
      {
      	ri=360-ri;
      }
		ri=(int)(ri+.5);
	}
	else
		ri=entf=0;
   qrb=(int) (entf*6371.299+.5);
   qtf=(int) ri;
}
/* =========================================================== */

